<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_HotelListRequest StructType
 * @subpackage Structs
 */
class JP_HotelListRequest extends AbstractStructBase
{
    /**
     * The Suppliers
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString5
     */
    public $Suppliers;
    /**
     * The ZoneCode
     * @var string
     */
    public $ZoneCode;
    /**
     * The ShowBasicInfo
     * @var bool
     */
    public $ShowBasicInfo;
    /**
     * Constructor method for JP_HotelListRequest
     * @uses JP_HotelListRequest::setSuppliers()
     * @uses JP_HotelListRequest::setZoneCode()
     * @uses JP_HotelListRequest::setShowBasicInfo()
     * @param \ArrayType\ArrayOfString5 $suppliers
     * @param string $zoneCode
     * @param bool $showBasicInfo
     */
    public function __construct(\ArrayType\ArrayOfString5 $suppliers = null, $zoneCode = null, $showBasicInfo = null)
    {
        $this
            ->setSuppliers($suppliers)
            ->setZoneCode($zoneCode)
            ->setShowBasicInfo($showBasicInfo);
    }
    /**
     * Get Suppliers value
     * @return \ArrayType\ArrayOfString5|null
     */
    public function getSuppliers()
    {
        return $this->Suppliers;
    }
    /**
     * Set Suppliers value
     * @param \ArrayType\ArrayOfString5 $suppliers
     * @return \StructType\JP_HotelListRequest
     */
    public function setSuppliers(\ArrayType\ArrayOfString5 $suppliers = null)
    {
        $this->Suppliers = $suppliers;
        return $this;
    }
    /**
     * Get ZoneCode value
     * @return string|null
     */
    public function getZoneCode()
    {
        return $this->ZoneCode;
    }
    /**
     * Set ZoneCode value
     * @param string $zoneCode
     * @return \StructType\JP_HotelListRequest
     */
    public function setZoneCode($zoneCode = null)
    {
        // validation for constraint: string
        if (!is_null($zoneCode) && !is_string($zoneCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($zoneCode)), __LINE__);
        }
        $this->ZoneCode = $zoneCode;
        return $this;
    }
    /**
     * Get ShowBasicInfo value
     * @return bool|null
     */
    public function getShowBasicInfo()
    {
        return $this->ShowBasicInfo;
    }
    /**
     * Set ShowBasicInfo value
     * @param bool $showBasicInfo
     * @return \StructType\JP_HotelListRequest
     */
    public function setShowBasicInfo($showBasicInfo = null)
    {
        // validation for constraint: boolean
        if (!is_null($showBasicInfo) && !is_bool($showBasicInfo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($showBasicInfo)), __LINE__);
        }
        $this->ShowBasicInfo = $showBasicInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_HotelListRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
